<?php

// Search folder for files
//
function findfile ($location='', $fileregex='') {
   if (!$location or !is_dir($location) or !$fileregex) {
      return false;
   }
   $matchedfiles = array();
   $all = opendir($location);
   while ($file = readdir($all)) {
      if (!is_dir($location.'/'.$file)) {
         if (preg_match($fileregex,$file)) {
            array_push($matchedfiles,$location.'/'.$file);
         }
      }
   }
   closedir($all);
   unset($all);
   return $matchedfiles;
}

// changes file extension
//
function change_file_ext( $fname, $newext )
{
     if (!preg_match('/(\S+)\.(\S+)$/', basename($fname), $matches)) {
       return $fname.'.'.$newext;
     }
     $sf = $matches[1];
     return $sf . '.' . $newext;
}

// write word to file
//
function write_word( $f, $w )
{
    $b2 = chr(($w & 0xFF00) >> 8);
    $b1 = chr($w & 0xFF);
    fwrite($f, $b1, 1);
    fwrite($f, $b2, 1);
}

  /////////////////////////////////////////////////////////////////////////////

  $pngfiles = findfile('.', '/\.(png|PNG|pnG|pNg|pNG|Png|PnG|PNg)$/');
  sort($pngfiles);

  $old_imgnum = -1;
  $sprcount = 0;

  $fcount = count($pngfiles);
  for ($idx=0; $idx < $fcount; $idx++)
  {
    $infname = $pngfiles[$idx];
    // files must be named XXX_YYY_ABCD....PNG where YYY is number of sprites in this file
    if (!preg_match('/^(\d+)_(\d+)_(.+)\.\S+$/', basename($infname), $arr)) continue;

    $imgnum = intval($arr[1]);
    $sprnum = intval($arr[2]);

    if ($imgnum != $old_imgnum) {
      if ($old_imgnum >= 0) {
        fseek($g, 0, SEEK_SET);
        write_word($g, $sprcount);
        fclose($g);
      }
      $outfname = $arr[1]."_".$arr[3].".454";
      $g = fopen($outfname, "w");
      write_word($g, 1);
      echo $infname." -> ".$outfname."\n";
      $sprcount = 0;
      $old_imgnum = $imgnum;
    }

    list($dx, $dy) = getimagesize($infname);
    $img = ImageCreateFromPng($infname);

    // checking for appropriate alpha-channel presence
    $isalpha = 0;
    for ($i=0; $i<$dy; $i++) {
      for ($j=0; $j<$dx; $j++) {
        $rgb = ImageColorAt($img, $j, $i);
        $ca = ($rgb >> 24) & 0x7F;  // Alpha (0..127)
        if ($ca >= (0x80 >> 3)) { $isalpha = 1; break; } // if alpha-channel values >= 1/8 * Max.alpha - alpha channel is present then
      }
      if ($isalpha == 1) break;
    }

    // write out dimensions
    write_word($g, $dx);
    write_word($g, $dy);
    // use alpha channel or not
    write_word($g, $isalpha);

    $data = "";
    for ($i=0; $i<$dy; $i++)
      for ($j=0; $j<$dx; $j++) {
        $rgb = ImageColorAt($img, $j, $i);

        $ca = ($rgb >> 24) & 0x7F;  // Alpha (0..127)
        $cr = ($rgb >> 16) & 0xFF;  // Red   (0..255)
        $cg = ($rgb >> 8) & 0xFF;   // Green (0..255)
        $cb = $rgb & 0xFF;          // Blue  (0..255)

        $ca = $ca >> 4; // Alpha 3-bits
        $cr = $cr >> 4; // Red   4-bits
        $cg = $cg >> 3; // Green 5-bits
        $cb = $cb >> 4; // Blue  4-bits

        if ($isalpha == 1) {
          $cr = intval(round($cr * (1.0 - ($ca / 7.0))));
          $cg = intval(round($cg * (1.0 - ($ca / 7.0))));
          $cb = intval(round($cb * (1.0 - ($ca / 7.0))));
        } else {
          $ca = 0;
        }

        $w = (($ca << 13) | ($cr << 9) | ($cg << 4) | $cb) & 0xFFFF;
        $data = $data . chr($w & 0xFF);
        $data = $data . chr(($w>>8) & 0xFF);
      }

    // resulting data will be compressed
    $compdata = gzcompress($data, 9);
    $w = strlen($compdata);
    // write compressed data size
    write_word($g, ($w & 0xFFFF));
    write_word($g, (($w>>16) & 0xFFFF));
    // write compressed data itself
    fwrite($g, $compdata, $w);

    $sprcount++;
  }

  if ($old_imgnum >= 0) {
    fseek($g, 0, SEEK_SET);
    write_word($g, $sprcount);
    fclose($g);
  }
?>