//
// hud.h
// Header for hud.cpp
//

#ifndef __HUD_H__
#define __HUD_H__


class TGame_radio_node;


// HUD class: Score, Highscore, ship energy and others non-clickable information
//
class TIface_hud: public TIfaceElement {
    public:
        TIface_hud ( TSurface * sf );
        void Draw ( void );
};


// Radio class: for ship's communications
//
class TGame_radio: public TGameElement {
    public:

        TGame_radio_node * first;

        TGame_radio ( TSurface * sf );
        ~TGame_radio ();

        void Draw ( void );
        void TimerTick ( void );

        void Talk ( int fsprnum, CString ftitle, CString ftext );
};


// 'Speech' for radio class
//
class TGame_radio_node {
    public:
        int         state;
        int         wtick;
        double      head_x;
        double      head_y;
        int         head_hlight;
        int         head_sprnum;
        double      title_x;
        double      title_y;
        CString     title;
        double      text_x;
        double      text_y;
        int         text_lines;
        CString     text;

        TGame_radio_node * next;
        TGame_radio_node * prev;
        TGame_radio * parent;

        TGame_radio_node ( TGame_radio * fparent, TGame_radio_node * fprev );
        ~TGame_radio_node ();

        void Draw ( void );
        void TimerTick ( void );
};



#endif // __HUD_H_