//
// sound.h
// Header for sound.cpp
//

#ifndef __SOUND_H_
#define __SOUND_H_

// maximum number of in-game sound samples
// 
#define MAX_SAMPLES_COUNT           16


class TSoundSystem {
    public:
        TSurface      * surface;

        BOOL            fmod_init_result;

        FSOUND_STREAM * stream;
        FSOUND_SAMPLE * sample[MAX_SAMPLES_COUNT];
        BOOL            sample_disposable[MAX_SAMPLES_COUNT];

        TSoundSystem ( TSurface * sf );
        ~TSoundSystem ();

        void LoadSample ( LPCTSTR folder, LPCTSTR fname, BOOL is_disposable );
        void LoadCommonSamples ( void );
        void LoadLevelSamples ( int lev_num );
        void PlaySample( int num );
        void PlayMusic ( LPCTSTR s );
};


#endif // __SOUND_H_
